/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.296 Revision 1.409
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.296 2008/02/13 20:50:06 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.409 2012/10/23 21:09:39 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
19 20
20DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
22
23if has "${EAPI:-0}" 0 1 2; then
21 24
22# @FUNCTION: epause 25# @FUNCTION: epause
23# @USAGE: [seconds] 26# @USAGE: [seconds]
24# @DESCRIPTION: 27# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 29# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 31# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 32epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 34}
32 35
33# @FUNCTION: ebeep 36# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 37# @USAGE: [number of beeps]
35# @DESCRIPTION: 38# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 39# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 40# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 42# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 43ebeep() {
41 local n 44 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 47 echo -ne "\a"
47 sleep 1 50 sleep 1
48 done 51 done
49 fi 52 fi
50} 53}
51 54
52# Default directory where patches are located 55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
167# return 0
168# fi
169# done
170# eshopts_pop
171# @CODE
172eshopts_push() {
173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
182}
183
184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
56# Default options for patch 229# @VARIABLE: EPATCH_OPTS
230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 242# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 243# -E - automatically remove empty files
244# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
62# and not the full path .. 249# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
64# Change the printed message for a single patch. 253# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
255# @VARIABLE: EPATCH_MULTI_MSG
256# @DESCRIPTION:
66# Change the printed message for multiple patches. 257# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 259# @VARIABLE: EPATCH_FORCE
69# 260# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 261# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 262# arch naming style.
72EPATCH_FORCE="no" 263EPATCH_FORCE="no"
73 264
74# This function is for bulk patching, or in theory for just one 265# @FUNCTION: epatch
75# or two patches. 266# @USAGE: [options] [patches] [dirs of patches]
267# @DESCRIPTION:
268# epatch is designed to greatly simplify the application of patches. It can
269# process patch files directly, or directories of patches. The patches may be
270# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
271# the -p option as epatch will automatically attempt -p0 to -p5 until things
272# apply successfully.
76# 273#
77# It should work with .bz2, .gz, .zip and plain text patches. 274# If you do not specify any patches/dirs, then epatch will default to the
78# Currently all patches should be the same format. 275# directory specified by EPATCH_SOURCE.
79# 276#
80# You do not have to specify '-p' option to patch, as it will 277# Any options specified that start with a dash will be passed down to patch
81# try with -p0 to -p5 until it succeed, or fail at -p5. 278# for this specific invocation. As soon as an arg w/out a dash is found, then
279# arg processing stops.
82# 280#
83# Above EPATCH_* variables can be used to control various defaults, 281# When processing directories, epatch will apply all patches that match:
84# bug they should be left as is to ensure an ebuild can rely on 282# @CODE
85# them for. 283# if ${EPATCH_FORCE} != "yes"
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 284# ??_${ARCH}_foo.${EPATCH_SUFFIX}
285# else
286# *.${EPATCH_SUFFIX}
287# @CODE
288# The leading ?? are typically numbers used to force consistent patch ordering.
289# The arch field is used to apply patches only for the host architecture with
290# the special value of "all" means apply for everyone. Note that using values
291# other than "all" is highly discouraged -- you should apply patches all the
292# time and let architecture details be detected at configure/compile time.
92# 293#
93# For example: 294# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
295# for patches to apply.
94# 296#
95# 01_all_misc-fix.patch.bz2 297# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 298epatch() {
108 _epatch_draw_line() { 299 _epatch_draw_line() {
300 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 301 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 302 echo "${1//?/=}"
111 } 303 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 304
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 305 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 306
122 if [ "$#" -gt 1 ] 307 # First process options. We localize the EPATCH_OPTS setting
123 then 308 # from above so that we can pass it on in the loop below with
309 # any additional values the user has specified.
310 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
311 while [[ $# -gt 0 ]] ; do
312 case $1 in
313 -*) EPATCH_OPTS+=( "$1" ) ;;
314 *) break ;;
315 esac
316 shift
317 done
318
319 # Let the rest of the code process one user arg at a time --
320 # each arg may expand into multiple patches, and each arg may
321 # need to start off with the default global EPATCH_xxx values
322 if [[ $# -gt 1 ]] ; then
124 local m="" 323 local m
125 for m in "$@" ; do 324 for m in "$@" ; do
126 epatch "${m}" 325 epatch "${m}"
127 done 326 done
128 return 0 327 return 0
129 fi 328 fi
130 329
131 if [ -n "$1" -a -f "$1" ] 330 local SINGLE_PATCH="no"
132 then 331 # no args means process ${EPATCH_SOURCE}
332 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
333
334 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 335 SINGLE_PATCH="yes"
134 336 set -- "$1"
135 local EPATCH_SOURCE="$1" 337 # Use the suffix from the single patch (localize it); the code
338 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 339 local EPATCH_SUFFIX=$1
137 340
138 elif [ -n "$1" -a -d "$1" ] 341 elif [[ -d $1 ]] ; then
139 then 342 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 343 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 344
345 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
346 # Re-use EPATCH_SOURCE as a search dir
347 epatch "${EPATCH_SOURCE}/$1"
348 return $?
349
350 else
351 # sanity check ... if it isn't a dir or file, wtf man ?
352 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
353 echo
354 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
355 eerror
356 eerror " ${EPATCH_SOURCE}"
357 eerror " ( ${EPATCH_SOURCE##*/} )"
358 echo
359 die "Cannot find \$EPATCH_SOURCE!"
360 fi
361
362 # Now that we know we're actually going to apply something, merge
363 # all of the patch options back in to a single variable for below.
364 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
365
366 local PIPE_CMD
367 case ${EPATCH_SUFFIX##*\.} in
368 xz) PIPE_CMD="xz -dc" ;;
369 lzma) PIPE_CMD="lzma -dc" ;;
370 bz2) PIPE_CMD="bzip2 -dc" ;;
371 gz|Z|z) PIPE_CMD="gzip -dc" ;;
372 ZIP|zip) PIPE_CMD="unzip -p" ;;
373 *) ;;
374 esac
375
376 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
377
378 local x
379 for x in "$@" ; do
380 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
381 # didn't match anything, ignore continue on
382 [[ ! -f ${x} ]] && continue
383
384 local patchname=${x##*/}
385
386 # Apply single patches, or forced sets of patches, or
387 # patches with ARCH dependant names.
388 # ???_arch_foo.patch
389 # Else, skip this input altogether
390 local a=${patchname#*_} # strip the ???_
391 a=${a%%_*} # strip the _foo.patch
392 if ! [[ ${SINGLE_PATCH} == "yes" || \
393 ${EPATCH_FORCE} == "yes" || \
394 ${a} == all || \
395 ${a} == ${ARCH} ]]
142 then 396 then
143 local EPATCH_SOURCE="$1/*" 397 continue
398 fi
399
400 # Let people filter things dynamically
401 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
402 # let people use globs in the exclude
403 eshopts_push -o noglob
404
405 local ex
406 for ex in ${EPATCH_EXCLUDE} ; do
407 if [[ ${patchname} == ${ex} ]] ; then
408 eshopts_pop
409 continue 2
410 fi
411 done
412
413 eshopts_pop
414 fi
415
416 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
417 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
418 einfo "${EPATCH_SINGLE_MSG}"
419 else
420 einfo "Applying ${patchname} ..."
421 fi
144 else 422 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 423 einfo " ${patchname} ..."
146 fi 424 fi
147 else 425
148 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 426 # most of the time, there will only be one run per unique name,
149 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 427 # but if there are more, make sure we get unique log filenames
150 then 428 local STDERR_TARGET="${T}/${patchname}.out"
151 EPATCH_SOURCE="$1" 429 if [[ -e ${STDERR_TARGET} ]] ; then
430 STDERR_TARGET="${T}/${patchname}-$$.out"
431 fi
432
433 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
434
435 # Decompress the patch if need be
436 local count=0
437 local PATCH_TARGET
438 if [[ -n ${PIPE_CMD} ]] ; then
439 PATCH_TARGET="${T}/$$.patch"
440 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
441
442 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
443 echo
444 eerror "Could not extract patch!"
445 #die "Could not extract patch!"
446 count=5
447 break
152 fi 448 fi
449 else
450 PATCH_TARGET=${x}
451 fi
153 452
453 # Check for absolute paths in patches. If sandbox is disabled,
454 # people could (accidently) patch files in the root filesystem.
455 # Or trigger other unpleasantries #237667. So disallow -p0 on
456 # such patches.
457 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
458 if [[ -n ${abs_paths} ]] ; then
459 count=1
460 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
461 fi
462 # Similar reason, but with relative paths.
463 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
464 if [[ -n ${rel_paths} ]] ; then
465 eqawarn "QA Notice: Your patch uses relative paths '../'."
466 eqawarn " In the future this will cause a failure."
467 eqawarn "${rel_paths}"
468 fi
469
470 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
471 local patch_cmd
472 while [[ ${count} -lt 5 ]] ; do
473 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
474
475 # Generate some useful debug info ...
476 (
477 _epatch_draw_line "***** ${patchname} *****"
154 echo 478 echo
155 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 479 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
480 echo
481 _epatch_draw_line "***** ${patchname} *****"
482 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
483 ret=$?
484 echo
485 echo "patch program exited with status ${ret}"
486 exit ${ret}
487 ) >> "${STDERR_TARGET}"
488
489 if [ $? -eq 0 ] ; then
490 (
491 _epatch_draw_line "***** ${patchname} *****"
492 echo
493 echo "ACTUALLY APPLYING ${patchname} ..."
494 echo
495 _epatch_draw_line "***** ${patchname} *****"
496 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
497 ret=$?
498 echo
499 echo "patch program exited with status ${ret}"
500 exit ${ret}
501 ) >> "${STDERR_TARGET}"
502
503 if [ $? -ne 0 ] ; then
504 echo
505 eerror "A dry-run of patch command succeeded, but actually"
506 eerror "applying the patch failed!"
507 #die "Real world sux compared to the dreamworld!"
508 count=5
509 fi
510 break
511 fi
512
513 : $(( count++ ))
514 done
515
516 # if we had to decompress the patch, delete the temp one
517 if [[ -n ${PIPE_CMD} ]] ; then
518 rm -f "${PATCH_TARGET}"
519 fi
520
521 if [[ ${count} -ge 5 ]] ; then
522 echo
523 eerror "Failed Patch: ${patchname} !"
524 eerror " ( ${PATCH_TARGET} )"
156 eerror 525 eerror
157 eerror " ${EPATCH_SOURCE}" 526 eerror "Include in your bugreport the contents of:"
158 eerror " ( ${EPATCH_SOURCE##*/} )" 527 eerror
528 eerror " ${STDERR_TARGET}"
159 echo 529 echo
160 die "Cannot find \$EPATCH_SOURCE!"
161 fi
162
163 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
164 fi
165
166 case ${EPATCH_SUFFIX##*\.} in
167 bz2)
168 PIPE_CMD="bzip2 -dc"
169 PATCH_SUFFIX="bz2"
170 ;;
171 gz|Z|z)
172 PIPE_CMD="gzip -dc"
173 PATCH_SUFFIX="gz"
174 ;;
175 ZIP|zip)
176 PIPE_CMD="unzip -p"
177 PATCH_SUFFIX="zip"
178 ;;
179 *)
180 PIPE_CMD="cat"
181 PATCH_SUFFIX="patch"
182 ;;
183 esac
184
185 if [ "${SINGLE_PATCH}" = "no" ]
186 then
187 einfo "${EPATCH_MULTI_MSG}"
188 fi
189 for x in ${EPATCH_SOURCE}
190 do
191 # New ARCH dependant patch naming scheme ...
192 #
193 # ???_arch_foo.patch
194 #
195 if [ -f ${x} ] && \
196 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
197 [ "${EPATCH_FORCE}" = "yes" ])
198 then
199 local count=0
200 local popts="${EPATCH_OPTS}"
201 local patchname=${x##*/}
202
203 if [ -n "${EPATCH_EXCLUDE}" ]
204 then
205 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
206 then
207 continue
208 fi
209 fi
210
211 if [ "${SINGLE_PATCH}" = "yes" ]
212 then
213 if [ -n "${EPATCH_SINGLE_MSG}" ]
214 then
215 einfo "${EPATCH_SINGLE_MSG}"
216 else
217 einfo "Applying ${patchname} ..."
218 fi
219 else
220 einfo " ${patchname} ..."
221 fi
222
223 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
224 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225
226 # Allow for prefix to differ ... im lazy, so shoot me :/
227 while [ "${count}" -lt 5 ]
228 do
229 # Generate some useful debug info ...
230 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
231 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232
233 if [ "${PATCH_SUFFIX}" != "patch" ]
234 then
235 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
236 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 else
238 PATCH_TARGET="${x}"
239 fi
240
241 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
242 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243
244 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 if [ "${PATCH_SUFFIX}" != "patch" ]
248 then
249 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
250 then
251 echo
252 eerror "Could not extract patch!"
253 #die "Could not extract patch!"
254 count=5
255 break
256 fi
257 fi
258
259 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
260 then
261 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266
267 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
268 _epatch_assert
269
270 if [ "$?" -ne 0 ]
271 then
272 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279
280 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
281
282 break
283 fi
284
285 count=$((count + 1))
286 done
287
288 if [ "${PATCH_SUFFIX}" != "patch" ]
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${patchname} !"
297 eerror " ( ${PATCH_TARGET} )"
298 eerror
299 eerror "Include in your bugreport the contents of:"
300 eerror
301 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
302 echo
303 die "Failed Patch: ${patchname}!" 530 die "Failed Patch: ${patchname}!"
304 fi 531 fi
305 532
306 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 533 # if everything worked, delete the full debug patch log
534 rm -f "${STDERR_TARGET}"
307 535
536 # then log away the exact stuff for people to review later
537 cat <<-EOF >> "${T}/epatch.log"
538 PATCH: ${x}
539 CMD: ${patch_cmd}
540 PWD: ${PWD}
541
542 EOF
308 eend 0 543 eend 0
309 fi
310 done 544 done
311 if [ "${SINGLE_PATCH}" = "no" ] 545
312 then 546 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
313 einfo "Done with patching" 547 : # everything worked
548}
549
550# @FUNCTION: epatch_user
551# @USAGE:
552# @DESCRIPTION:
553# Applies user-provided patches to the source tree. The patches are
554# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
555# of these three directories to exist will be the one to use, ignoring
556# any more general directories which might exist as well. They must end
557# in ".patch" to be applied.
558#
559# User patches are intended for quick testing of patches without ebuild
560# modifications, as well as for permanent customizations a user might
561# desire. Obviously, there can be no official support for arbitrarily
562# patched ebuilds. So whenever a build log in a bug report mentions that
563# user patches were applied, the user should be asked to reproduce the
564# problem without these.
565#
566# Not all ebuilds do call this function, so placing patches in the
567# stated directory might or might not work, depending on the package and
568# the eclasses it inherits and uses. It is safe to call the function
569# repeatedly, so it is always possible to add a call at the ebuild
570# level. The first call is the time when the patches will be
571# applied.
572#
573# Ideally, this function should be called after gentoo-specific patches
574# have been applied, so that their code can be modified as well, but
575# before calls to e.g. eautoreconf, as the user patches might affect
576# autotool input files as well.
577epatch_user() {
578 [[ $# -ne 0 ]] && die "epatch_user takes no options"
579
580 # Allow multiple calls to this function; ignore all but the first
581 local applied="${T}/epatch_user.log"
582 [[ -e ${applied} ]] && return 2
583
584 # don't clobber any EPATCH vars that the parent might want
585 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
586 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
587 EPATCH_SOURCE=${base}/${CTARGET}/${check}
588 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
589 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
590 if [[ -d ${EPATCH_SOURCE} ]] ; then
591 EPATCH_SOURCE=${EPATCH_SOURCE} \
592 EPATCH_SUFFIX="patch" \
593 EPATCH_FORCE="yes" \
594 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
595 epatch
596 echo "${EPATCH_SOURCE}" > "${applied}"
597 return 0
314 fi 598 fi
599 done
600 echo "none" > "${applied}"
601 return 1
315} 602}
316 603
317# @FUNCTION: emktemp 604# @FUNCTION: emktemp
318# @USAGE: [temp dir] 605# @USAGE: [temp dir]
319# @DESCRIPTION: 606# @DESCRIPTION:
347 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 634 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
348 fi 635 fi
349 fi 636 fi
350} 637}
351 638
352# @FUNCTION: egetent
353# @USAGE: <database> <key>
354# @MAINTAINER:
355# base-system@gentoo.org (Linux)
356# Joe Jezak <josejx@gmail.com> (OS X)
357# usata@gentoo.org (OS X)
358# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
359# @DESCRIPTION:
360# Small wrapper for getent (Linux), nidump (Mac OS X),
361# and pw (FreeBSD) used in enewuser()/enewgroup()
362egetent() {
363 case ${CHOST} in
364 *-darwin*)
365 case "$2" in
366 *[!0-9]*) # Non numeric
367 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
368 ;;
369 *) # Numeric
370 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
371 ;;
372 esac
373 ;;
374 *-freebsd*|*-dragonfly*)
375 local opts action="user"
376 [[ $1 == "passwd" ]] || action="group"
377
378 # lookup by uid/gid
379 if [[ $2 == [[:digit:]]* ]] ; then
380 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
381 fi
382
383 pw show ${action} ${opts} "$2" -q
384 ;;
385 *-netbsd*|*-openbsd*)
386 grep "$2:\*:" /etc/$1
387 ;;
388 *)
389 type -p nscd >& /dev/null && nscd -i "$1"
390 getent "$1" "$2"
391 ;;
392 esac
393}
394
395# @FUNCTION: enewuser
396# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
397# @DESCRIPTION:
398# Same as enewgroup, you are not required to understand how to properly add
399# a user to the system. The only required parameter is the username.
400# Default uid is (pass -1 for this) next available, default shell is
401# /bin/false, default homedir is /dev/null, there are no default groups,
402# and default params sets the comment as 'added by portage for ${PN}'.
403enewuser() {
404 case ${EBUILD_PHASE} in
405 unpack|compile|test|install)
406 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
407 eerror "Package fails at QA and at life. Please file a bug."
408 die "Bad package! enewuser is only for use in pkg_* functions!"
409 esac
410
411 # get the username
412 local euser=$1; shift
413 if [[ -z ${euser} ]] ; then
414 eerror "No username specified !"
415 die "Cannot call enewuser without a username"
416 fi
417
418 # lets see if the username already exists
419 if [[ -n $(egetent passwd "${euser}") ]] ; then
420 return 0
421 fi
422 einfo "Adding user '${euser}' to your system ..."
423
424 # options to pass to useradd
425 local opts=
426
427 # handle uid
428 local euid=$1; shift
429 if [[ -n ${euid} && ${euid} != -1 ]] ; then
430 if [[ ${euid} -gt 0 ]] ; then
431 if [[ -n $(egetent passwd ${euid}) ]] ; then
432 euid="next"
433 fi
434 else
435 eerror "Userid given but is not greater than 0 !"
436 die "${euid} is not a valid UID"
437 fi
438 else
439 euid="next"
440 fi
441 if [[ ${euid} == "next" ]] ; then
442 for ((euid = 101; euid <= 999; euid++)); do
443 [[ -z $(egetent passwd ${euid}) ]] && break
444 done
445 fi
446 opts="${opts} -u ${euid}"
447 einfo " - Userid: ${euid}"
448
449 # handle shell
450 local eshell=$1; shift
451 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
452 if [[ ! -e ${ROOT}${eshell} ]] ; then
453 eerror "A shell was specified but it does not exist !"
454 die "${eshell} does not exist in ${ROOT}"
455 fi
456 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
457 eerror "Do not specify ${eshell} yourself, use -1"
458 die "Pass '-1' as the shell parameter"
459 fi
460 else
461 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
462 [[ -x ${ROOT}${shell} ]] && break
463 done
464
465 if [[ ${shell} == "/dev/null" ]] ; then
466 eerror "Unable to identify the shell to use, proceeding with userland default."
467 case ${USERLAND} in
468 GNU) shell="/bin/false" ;;
469 BSD) shell="/sbin/nologin" ;;
470 Darwin) shell="/usr/sbin/nologin" ;;
471 *) die "Unable to identify the default shell for userland ${USERLAND}"
472 esac
473 fi
474
475 eshell=${shell}
476 fi
477 einfo " - Shell: ${eshell}"
478 opts="${opts} -s ${eshell}"
479
480 # handle homedir
481 local ehome=$1; shift
482 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
483 ehome="/dev/null"
484 fi
485 einfo " - Home: ${ehome}"
486 opts="${opts} -d ${ehome}"
487
488 # handle groups
489 local egroups=$1; shift
490 if [[ ! -z ${egroups} ]] ; then
491 local oldifs=${IFS}
492 local defgroup="" exgroups=""
493
494 export IFS=","
495 for g in ${egroups} ; do
496 export IFS=${oldifs}
497 if [[ -z $(egetent group "${g}") ]] ; then
498 eerror "You must add group ${g} to the system first"
499 die "${g} is not a valid GID"
500 fi
501 if [[ -z ${defgroup} ]] ; then
502 defgroup=${g}
503 else
504 exgroups="${exgroups},${g}"
505 fi
506 export IFS=","
507 done
508 export IFS=${oldifs}
509
510 opts="${opts} -g ${defgroup}"
511 if [[ ! -z ${exgroups} ]] ; then
512 opts="${opts} -G ${exgroups:1}"
513 fi
514 else
515 egroups="(none)"
516 fi
517 einfo " - Groups: ${egroups}"
518
519 # handle extra and add the user
520 local oldsandbox=${SANDBOX_ON}
521 export SANDBOX_ON="0"
522 case ${CHOST} in
523 *-darwin*)
524 ### Make the user
525 if [[ -z $@ ]] ; then
526 dscl . create /users/${euser} uid ${euid}
527 dscl . create /users/${euser} shell ${eshell}
528 dscl . create /users/${euser} home ${ehome}
529 dscl . create /users/${euser} realname "added by portage for ${PN}"
530 ### Add the user to the groups specified
531 local oldifs=${IFS}
532 export IFS=","
533 for g in ${egroups} ; do
534 dscl . merge /groups/${g} users ${euser}
535 done
536 export IFS=${oldifs}
537 else
538 einfo "Extra options are not supported on Darwin yet"
539 einfo "Please report the ebuild along with the info below"
540 einfo "eextra: $@"
541 die "Required function missing"
542 fi
543 ;;
544 *-freebsd*|*-dragonfly*)
545 if [[ -z $@ ]] ; then
546 pw useradd ${euser} ${opts} \
547 -c "added by portage for ${PN}" \
548 die "enewuser failed"
549 else
550 einfo " - Extra: $@"
551 pw useradd ${euser} ${opts} \
552 "$@" || die "enewuser failed"
553 fi
554 ;;
555
556 *-netbsd*)
557 if [[ -z $@ ]] ; then
558 useradd ${opts} ${euser} || die "enewuser failed"
559 else
560 einfo " - Extra: $@"
561 useradd ${opts} ${euser} "$@" || die "enewuser failed"
562 fi
563 ;;
564
565 *-openbsd*)
566 if [[ -z $@ ]] ; then
567 useradd -u ${euid} -s ${eshell} \
568 -d ${ehome} -c "Added by portage for ${PN}" \
569 -g ${egroups} ${euser} || die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 useradd -u ${euid} -s ${eshell} \
573 -d ${ehome} -c "Added by portage for ${PN}" \
574 -g ${egroups} ${euser} "$@" || die "enewuser failed"
575 fi
576 ;;
577
578 *)
579 if [[ -z $@ ]] ; then
580 useradd ${opts} ${euser} \
581 -c "added by portage for ${PN}" \
582 || die "enewuser failed"
583 else
584 einfo " - Extra: $@"
585 useradd ${opts} ${euser} "$@" \
586 || die "enewuser failed"
587 fi
588 ;;
589 esac
590
591 if [[ ! -e ${ROOT}/${ehome} ]] ; then
592 einfo " - Creating ${ehome} in ${ROOT}"
593 mkdir -p "${ROOT}/${ehome}"
594 chown ${euser} "${ROOT}/${ehome}"
595 chmod 755 "${ROOT}/${ehome}"
596 fi
597
598 export SANDBOX_ON=${oldsandbox}
599}
600
601# @FUNCTION: enewgroup
602# @USAGE: <group> [gid]
603# @DESCRIPTION:
604# This function does not require you to understand how to properly add a
605# group to the system. Just give it a group name to add and enewgroup will
606# do the rest. You may specify the gid for the group or allow the group to
607# allocate the next available one.
608enewgroup() {
609 case ${EBUILD_PHASE} in
610 unpack|compile|test|install)
611 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
612 eerror "Package fails at QA and at life. Please file a bug."
613 die "Bad package! enewgroup is only for use in pkg_* functions!"
614 esac
615
616 # get the group
617 local egroup="$1"; shift
618 if [ -z "${egroup}" ]
619 then
620 eerror "No group specified !"
621 die "Cannot call enewgroup without a group"
622 fi
623
624 # see if group already exists
625 if [[ -n $(egetent group "${egroup}") ]]; then
626 return 0
627 fi
628 einfo "Adding group '${egroup}' to your system ..."
629
630 # options to pass to useradd
631 local opts=
632
633 # handle gid
634 local egid="$1"; shift
635 if [ ! -z "${egid}" ]
636 then
637 if [ "${egid}" -gt 0 ]
638 then
639 if [ -z "`egetent group ${egid}`" ]
640 then
641 if [[ "${CHOST}" == *-darwin* ]]; then
642 opts="${opts} ${egid}"
643 else
644 opts="${opts} -g ${egid}"
645 fi
646 else
647 egid="next available; requested gid taken"
648 fi
649 else
650 eerror "Groupid given but is not greater than 0 !"
651 die "${egid} is not a valid GID"
652 fi
653 else
654 egid="next available"
655 fi
656 einfo " - Groupid: ${egid}"
657
658 # handle extra
659 local eextra="$@"
660 opts="${opts} ${eextra}"
661
662 # add the group
663 local oldsandbox="${SANDBOX_ON}"
664 export SANDBOX_ON="0"
665 case ${CHOST} in
666 *-darwin*)
667 if [ ! -z "${eextra}" ];
668 then
669 einfo "Extra options are not supported on Darwin/OS X yet"
670 einfo "Please report the ebuild along with the info below"
671 einfo "eextra: ${eextra}"
672 die "Required function missing"
673 fi
674
675 # If we need the next available
676 case ${egid} in
677 *[!0-9]*) # Non numeric
678 for ((egid = 101; egid <= 999; egid++)); do
679 [[ -z $(egetent group ${egid}) ]] && break
680 done
681 esac
682 dscl . create /groups/${egroup} gid ${egid}
683 dscl . create /groups/${egroup} passwd '*'
684 ;;
685
686 *-freebsd*|*-dragonfly*)
687 case ${egid} in
688 *[!0-9]*) # Non numeric
689 for ((egid = 101; egid <= 999; egid++)); do
690 [[ -z $(egetent group ${egid}) ]] && break
691 done
692 esac
693 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
694 ;;
695
696 *-netbsd*)
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
704 ;;
705
706 *)
707 groupadd ${opts} ${egroup} || die "enewgroup failed"
708 ;;
709 esac
710 export SANDBOX_ON="${oldsandbox}"
711}
712
713# @FUNCTION: edos2unix 639# @FUNCTION: edos2unix
714# @USAGE: <file> [more files ...] 640# @USAGE: <file> [more files ...]
715# @DESCRIPTION: 641# @DESCRIPTION:
716# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 642# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
717# to remove all of these text utilities from DEPEND variables because this 643# to remove all of these text utilities from DEPEND variables because this
718# is a script based solution. Just give it a list of files to convert and 644# is a script based solution. Just give it a list of files to convert and
719# they will all be changed from the DOS CRLF format to the UNIX LF format. 645# they will all be changed from the DOS CRLF format to the UNIX LF format.
720edos2unix() { 646edos2unix() {
721 echo "$@" | xargs sed -i 's/\r$//' 647 [[ $# -eq 0 ]] && return 0
648 sed -i 's/\r$//' -- "$@" || die
722} 649}
723 650
651# @FUNCTION: make_desktop_entry
652# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
653# @DESCRIPTION:
724# Make a desktop file ! 654# Make a .desktop file.
725# Great for making those icons in kde/gnome startmenu !
726# Amaze your friends ! Get the women ! Join today !
727# 655#
728# make_desktop_entry(<command>, [name], [icon], [type], [path]) 656# @CODE
729#
730# binary: what command does the app run with ? 657# binary: what command does the app run with ?
731# name: the name that will show up in the menu 658# name: the name that will show up in the menu
732# icon: give your little like a pretty little icon ... 659# icon: the icon to use in the menu entry
733# this can be relative (to /usr/share/pixmaps) or 660# this can be relative (to /usr/share/pixmaps) or
734# a full path to an icon 661# a full path to an icon
735# type: what kind of application is this ? for categories: 662# type: what kind of application is this?
663# for categories:
736# http://standards.freedesktop.org/menu-spec/latest/apa.html 664# http://standards.freedesktop.org/menu-spec/latest/apa.html
737# path: if your app needs to startup in a specific dir 665# if unset, function tries to guess from package's category
666# fields: extra fields to append to the desktop file; a printf string
667# @CODE
738make_desktop_entry() { 668make_desktop_entry() {
739 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 669 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
740 670
741 local exec=${1} 671 local exec=${1}
742 local name=${2:-${PN}} 672 local name=${2:-${PN}}
743 local icon=${3:-${PN}} 673 local icon=${3:-${PN}}
744 local type=${4} 674 local type=${4}
745 local path=${5} 675 local fields=${5}
746 676
747 if [[ -z ${type} ]] ; then 677 if [[ -z ${type} ]] ; then
748 local catmaj=${CATEGORY%%-*} 678 local catmaj=${CATEGORY%%-*}
749 local catmin=${CATEGORY##*-} 679 local catmin=${CATEGORY##*-}
750 case ${catmaj} in 680 case ${catmaj} in
751 app) 681 app)
752 case ${catmin} in 682 case ${catmin} in
753 accessibility) type=Accessibility;; 683 accessibility) type="Utility;Accessibility";;
754 admin) type=System;; 684 admin) type=System;;
755 antivirus) type=System;; 685 antivirus) type=System;;
756 arch) type=Archiving;; 686 arch) type="Utility;Archiving";;
757 backup) type=Archiving;; 687 backup) type="Utility;Archiving";;
758 cdr) type=DiscBurning;; 688 cdr) type="AudioVideo;DiscBurning";;
759 dicts) type=Dictionary;; 689 dicts) type="Office;Dictionary";;
760 doc) type=Documentation;; 690 doc) type=Documentation;;
761 editors) type=TextEditor;; 691 editors) type="Utility;TextEditor";;
762 emacs) type=TextEditor;; 692 emacs) type="Development;TextEditor";;
763 emulation) type=Emulator;; 693 emulation) type="System;Emulator";;
764 laptop) type=HardwareSettings;; 694 laptop) type="Settings;HardwareSettings";;
765 office) type=Office;; 695 office) type=Office;;
766 pda) type=PDA;; 696 pda) type="Office;PDA";;
767 vim) type=TextEditor;; 697 vim) type="Development;TextEditor";;
768 xemacs) type=TextEditor;; 698 xemacs) type="Development;TextEditor";;
769 *) type=;;
770 esac 699 esac
771 ;; 700 ;;
772 701
773 dev) 702 dev)
774 type="Development" 703 type="Development"
775 ;; 704 ;;
776 705
777 games) 706 games)
778 case ${catmin} in 707 case ${catmin} in
779 action|fps) type=ActionGame;; 708 action|fps) type=ActionGame;;
780 arcade) type=ArcadeGame;; 709 arcade) type=ArcadeGame;;
781 board) type=BoardGame;; 710 board) type=BoardGame;;
782 emulation) type=Emulator;; 711 emulation) type=Emulator;;
783 kids) type=KidsGame;; 712 kids) type=KidsGame;;
784 puzzle) type=LogicGame;; 713 puzzle) type=LogicGame;;
785 roguelike) type=RolePlaying;; 714 roguelike) type=RolePlaying;;
786 rpg) type=RolePlaying;; 715 rpg) type=RolePlaying;;
787 simulation) type=Simulation;; 716 simulation) type=Simulation;;
788 sports) type=SportsGame;; 717 sports) type=SportsGame;;
789 strategy) type=StrategyGame;; 718 strategy) type=StrategyGame;;
790 *) type=;;
791 esac 719 esac
792 type="Game;${type}" 720 type="Game;${type}"
793 ;; 721 ;;
794 722
795 gnome) 723 gnome)
804 type="Network;Email" 732 type="Network;Email"
805 ;; 733 ;;
806 734
807 media) 735 media)
808 case ${catmin} in 736 case ${catmin} in
737 gfx)
809 gfx) type=Graphics;; 738 type=Graphics
739 ;;
740 *)
741 case ${catmin} in
810 radio) type=Tuner;; 742 radio) type=Tuner;;
811 sound) type=Audio;; 743 sound) type=Audio;;
812 tv) type=TV;; 744 tv) type=TV;;
813 video) type=Video;; 745 video) type=Video;;
814 *) type=;; 746 esac
747 type="AudioVideo;${type}"
748 ;;
815 esac 749 esac
816 type="AudioVideo;${type}"
817 ;; 750 ;;
818 751
819 net) 752 net)
820 case ${catmin} in 753 case ${catmin} in
821 dialup) type=Dialup;; 754 dialup) type=Dialup;;
822 ftp) type=FileTransfer;; 755 ftp) type=FileTransfer;;
823 im) type=InstantMessaging;; 756 im) type=InstantMessaging;;
824 irc) type=IRCClient;; 757 irc) type=IRCClient;;
825 mail) type=Email;; 758 mail) type=Email;;
826 news) type=News;; 759 news) type=News;;
827 nntp) type=News;; 760 nntp) type=News;;
828 p2p) type=FileTransfer;; 761 p2p) type=FileTransfer;;
829 *) type=;; 762 voip) type=Telephony;;
830 esac 763 esac
831 type="Network;${type}" 764 type="Network;${type}"
832 ;; 765 ;;
833 766
834 sci) 767 sci)
835 case ${catmin} in 768 case ${catmin} in
836 astro*) type=Astronomy;; 769 astro*) type=Astronomy;;
837 bio*) type=Biology;; 770 bio*) type=Biology;;
838 calc*) type=Calculator;; 771 calc*) type=Calculator;;
839 chem*) type=Chemistry;; 772 chem*) type=Chemistry;;
840 elec*) type=Electronics;; 773 elec*) type=Electronics;;
841 geo*) type=Geology;; 774 geo*) type=Geology;;
842 math*) type=Math;; 775 math*) type=Math;;
843 physics) type=Physics;; 776 physics) type=Physics;;
844 visual*) type=DataVisualization;; 777 visual*) type=DataVisualization;;
845 *) type=;;
846 esac 778 esac
847 type="Science;${type}" 779 type="Education;Science;${type}"
848 ;; 780 ;;
849 781
850 sys) 782 sys)
851 type="System" 783 type="System"
852 ;; 784 ;;
853 785
854 www) 786 www)
855 case ${catmin} in 787 case ${catmin} in
856 client) type=WebBrowser;; 788 client) type=WebBrowser;;
857 *) type=;;
858 esac 789 esac
859 type="Network" 790 type="Network;${type}"
860 ;; 791 ;;
861 792
862 *) 793 *)
863 type= 794 type=
864 ;; 795 ;;
870 local desktop_name="${PN}-${SLOT}" 801 local desktop_name="${PN}-${SLOT}"
871 fi 802 fi
872 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 803 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
873 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 804 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
874 805
806 # Don't append another ";" when a valid category value is provided.
807 type=${type%;}${type:+;}
808
809 eshopts_push -s extglob
810 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
811 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
812 ewarn "allowed in .desktop files if the value is not an absolute path."
813 icon=${icon%.@(xpm|png|svg)}
814 fi
815 eshopts_pop
816
875 cat <<-EOF > "${desktop}" 817 cat <<-EOF > "${desktop}"
876 [Desktop Entry] 818 [Desktop Entry]
877 Version=1.0
878 Name=${name} 819 Name=${name}
879 Type=Application 820 Type=Application
880 Comment=${DESCRIPTION} 821 Comment=${DESCRIPTION}
881 Exec=${exec} 822 Exec=${exec}
882 TryExec=${exec%% *} 823 TryExec=${exec%% *}
883 Icon=${icon} 824 Icon=${icon}
884 Categories=${type}; 825 Categories=${type}
885 EOF 826 EOF
886 827
887 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 828 if [[ ${fields:-=} != *=* ]] ; then
829 # 5th arg used to be value to Path=
830 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
831 fields="Path=${fields}"
832 fi
833 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
888 834
889 ( 835 (
890 # wrap the env here so that the 'insinto' call 836 # wrap the env here so that the 'insinto' call
891 # doesn't corrupt the env of the caller 837 # doesn't corrupt the env of the caller
892 insinto /usr/share/applications 838 insinto /usr/share/applications
893 doins "${desktop}" 839 doins "${desktop}"
894 ) 840 ) || die "installing desktop file failed"
895} 841}
896 842
897# @FUNCTION: validate_desktop_entries 843# @FUNCTION: validate_desktop_entries
898# @USAGE: [directories] 844# @USAGE: [directories]
899# @MAINTAINER: 845# @MAINTAINER:
921 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 867 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
922 fi 868 fi
923} 869}
924 870
925# @FUNCTION: make_session_desktop 871# @FUNCTION: make_session_desktop
926# @USAGE: <title> <command> 872# @USAGE: <title> <command> [command args...]
927# @DESCRIPTION: 873# @DESCRIPTION:
928# Make a GDM/KDM Session file. The title is the file to execute to start the 874# Make a GDM/KDM Session file. The title is the file to execute to start the
929# Window Manager. The command is the name of the Window Manager. 875# Window Manager. The command is the name of the Window Manager.
876#
877# You can set the name of the file via the ${wm} variable.
930make_session_desktop() { 878make_session_desktop() {
931 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 879 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
932 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 880 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
933 881
934 local title=$1 882 local title=$1
935 local command=$2 883 local command=$2
936 local desktop=${T}/${wm}.desktop 884 local desktop=${T}/${wm:-${PN}}.desktop
885 shift 2
937 886
938 cat <<-EOF > "${desktop}" 887 cat <<-EOF > "${desktop}"
939 [Desktop Entry] 888 [Desktop Entry]
940 Name=${title} 889 Name=${title}
941 Comment=This session logs you into ${title} 890 Comment=This session logs you into ${title}
942 Exec=${command} 891 Exec=${command} $*
943 TryExec=${command} 892 TryExec=${command}
944 Type=Application 893 Type=XSession
945 EOF 894 EOF
946 895
947 ( 896 (
948 # wrap the env here so that the 'insinto' call 897 # wrap the env here so that the 'insinto' call
949 # doesn't corrupt the env of the caller 898 # doesn't corrupt the env of the caller
991 insinto /usr/share/applications 940 insinto /usr/share/applications
992 newins "$@" 941 newins "$@"
993 ) 942 )
994} 943}
995 944
996# @FUNCTION: doicon 945# @FUNCTION: _iconins
997# @USAGE: <list of icons> 946# @INTERNAL
998# @DESCRIPTION: 947# @DESCRIPTION:
999# Install the list of icons into the icon directory (/usr/share/pixmaps). 948# function for use in doicon and newicon
1000# This is useful in conjunction with creating desktop/menu files. 949_iconins() {
1001doicon() {
1002 ( 950 (
1003 # wrap the env here so that the 'insinto' call 951 # wrap the env here so that the 'insinto' call
1004 # doesn't corrupt the env of the caller 952 # doesn't corrupt the env of the caller
1005 local i j ret 953 local funcname=$1; shift
1006 insinto /usr/share/pixmaps 954 local size dir
1007 for i in "$@" ; do 955 local context=apps
1008 if [[ -f ${i} ]] ; then 956 local theme=hicolor
1009 doins "${i}" 957
1010 ((ret+=$?)) 958 while [[ $# -gt 0 ]] ; do
1011 elif [[ -d ${i} ]] ; then 959 case $1 in
1012 for j in "${i}"/*.png ; do 960 -s|--size)
1013 doins "${j}" 961 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1014 ((ret+=$?)) 962 size=${2%%x*}
1015 done
1016 else 963 else
1017 ((++ret)) 964 size=${2}
1018 fi 965 fi
1019 done
1020 exit ${ret}
1021 )
1022}
1023
1024# @FUNCTION: newicon
1025# @USAGE: <icon> <newname>
1026# @DESCRIPTION:
1027# Like all other new* functions, install the specified icon as newname.
1028newicon() {
1029 (
1030 # wrap the env here so that the 'insinto' call
1031 # doesn't corrupt the env of the caller
1032 insinto /usr/share/pixmaps
1033 newins "$@"
1034 )
1035}
1036
1037# for internal use only (unpack_pdv and unpack_makeself)
1038find_unpackable_file() {
1039 local src=$1
1040 if [[ -z ${src} ]] ; then
1041 src=${DISTDIR}/${A}
1042 else
1043 if [[ -e ${DISTDIR}/${src} ]] ; then
1044 src=${DISTDIR}/${src}
1045 elif [[ -e ${PWD}/${src} ]] ; then
1046 src=${PWD}/${src}
1047 elif [[ -e ${src} ]] ; then
1048 src=${src}
1049 fi
1050 fi
1051 [[ ! -e ${src} ]] && return 1
1052 echo "${src}"
1053}
1054
1055# @FUNCTION: unpack_pdv
1056# @USAGE: <file to unpack> <size of off_t>
1057# @DESCRIPTION:
1058# Unpack those pesky pdv generated files ...
1059# They're self-unpacking programs with the binary package stuffed in
1060# the middle of the archive. Valve seems to use it a lot ... too bad
1061# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1062#
1063# You have to specify the off_t size ... I have no idea how to extract that
1064# information out of the binary executable myself. Basically you pass in
1065# the size of the off_t type (in bytes) on the machine that built the pdv
1066# archive.
1067#
1068# One way to determine this is by running the following commands:
1069#
1070# @CODE
1071# strings <pdv archive> | grep lseek
1072# strace -elseek <pdv archive>
1073# @CODE
1074#
1075# Basically look for the first lseek command (we do the strings/grep because
1076# sometimes the function call is _llseek or something) and steal the 2nd
1077# parameter. Here is an example:
1078#
1079# @CODE
1080# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1081# lseek
1082# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1083# lseek(3, -4, SEEK_END) = 2981250
1084# @CODE
1085#
1086# Thus we would pass in the value of '4' as the second parameter.
1087unpack_pdv() {
1088 local src=$(find_unpackable_file "$1")
1089 local sizeoff_t=$2
1090
1091 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1092 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1093
1094 local shrtsrc=$(basename "${src}")
1095 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1096 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1097 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1098
1099 # grab metadata for debug reasons
1100 local metafile=$(emktemp)
1101 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1102
1103 # rip out the final file name from the metadata
1104 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1105 datafile=$(basename "${datafile}")
1106
1107 # now lets uncompress/untar the file if need be
1108 local tmpfile=$(emktemp)
1109 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1110
1111 local iscompressed=$(file -b "${tmpfile}")
1112 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1113 iscompressed=1
1114 mv ${tmpfile}{,.Z}
1115 gunzip ${tmpfile}
1116 else
1117 iscompressed=0
1118 fi
1119 local istar=$(file -b "${tmpfile}")
1120 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1121 istar=1
1122 else
1123 istar=0
1124 fi
1125
1126 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1127 #dd if=${src} ibs=${metaskip} count=1 \
1128 # | dd ibs=${tailskip} skip=1 \
1129 # | gzip -dc \
1130 # > ${datafile}
1131 if [ ${iscompressed} -eq 1 ] ; then
1132 if [ ${istar} -eq 1 ] ; then
1133 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1134 | head -c $((${metaskip}-${tailskip})) \
1135 | tar -xzf -
1136 else
1137 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1138 | head -c $((${metaskip}-${tailskip})) \
1139 | gzip -dc \
1140 > ${datafile}
1141 fi
1142 else
1143 if [ ${istar} -eq 1 ] ; then
1144 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1145 | head -c $((${metaskip}-${tailskip})) \
1146 | tar --no-same-owner -xf -
1147 else
1148 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1149 | head -c $((${metaskip}-${tailskip})) \
1150 > ${datafile}
1151 fi
1152 fi
1153 true
1154 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1155 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1156}
1157
1158# @FUNCTION: unpack_makeself
1159# @USAGE: [file to unpack] [offset] [tail|dd]
1160# @DESCRIPTION:
1161# Unpack those pesky makeself generated files ...
1162# They're shell scripts with the binary package tagged onto
1163# the end of the archive. Loki utilized the format as does
1164# many other game companies.
1165#
1166# If the file is not specified, then ${A} is used. If the
1167# offset is not specified then we will attempt to extract
1168# the proper offset from the script itself.
1169unpack_makeself() {
1170 local src_input=${1:-${A}}
1171 local src=$(find_unpackable_file "${src_input}")
1172 local skip=$2
1173 local exe=$3
1174
1175 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1176
1177 local shrtsrc=$(basename "${src}")
1178 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1179 if [[ -z ${skip} ]] ; then
1180 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1181 local skip=0
1182 exe=tail
1183 case ${ver} in 966 case ${size} in
1184 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 967 16|22|24|32|36|48|64|72|96|128|192|256)
1185 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 968 size=${size}x${size};;
1186 ;; 969 scalable)
1187 2.0|2.0.1)
1188 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1189 ;;
1190 2.1.1)
1191 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1192 let skip="skip + 1"
1193 ;;
1194 2.1.2)
1195 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1196 let skip="skip + 1"
1197 ;;
1198 2.1.3)
1199 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1200 let skip="skip + 1"
1201 ;;
1202 2.1.4|2.1.5)
1203 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1204 skip=$(head -n ${skip} "${src}" | wc -c)
1205 exe="dd"
1206 ;; 970 ;;
1207 *) 971 *)
1208 eerror "I'm sorry, but I was unable to support the Makeself file." 972 eerror "${size} is an unsupported icon size!"
1209 eerror "The version I detected was '${ver}'." 973 exit 1;;
1210 eerror "Please file a bug about the file ${shrtsrc} at"
1211 eerror "http://bugs.gentoo.org/ so that support can be added."
1212 die "makeself version '${ver}' not supported"
1213 ;;
1214 esac 974 esac
1215 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 975 shift 2;;
1216 fi 976 -t|--theme)
1217 case ${exe} in 977 theme=${2}
1218 tail) exe="tail -n +${skip} '${src}'";; 978 shift 2;;
1219 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 979 -c|--context)
1220 *) die "makeself cant handle exe '${exe}'" 980 context=${2}
1221 esac 981 shift 2;;
1222
1223 # lets grab the first few bytes of the file to figure out what kind of archive it is
1224 local tmpfile=$(emktemp)
1225 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1226 local filetype=$(file -b "${tmpfile}")
1227 case ${filetype} in
1228 *tar\ archive*)
1229 eval ${exe} | tar --no-same-owner -xf -
1230 ;;
1231 bzip2*)
1232 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1233 ;;
1234 gzip*)
1235 eval ${exe} | tar --no-same-owner -xzf -
1236 ;;
1237 compress*)
1238 eval ${exe} | gunzip | tar --no-same-owner -xf -
1239 ;;
1240 *) 982 *)
1241 eerror "Unknown filetype \"${filetype}\" ?"
1242 false
1243 ;;
1244 esac
1245 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1246}
1247
1248# @FUNCTION: check_license
1249# @USAGE: [license]
1250# @DESCRIPTION:
1251# Display a license for user to accept. If no license is
1252# specified, then ${LICENSE} is used.
1253check_license() {
1254 local lic=$1
1255 if [ -z "${lic}" ] ; then
1256 lic="${PORTDIR}/licenses/${LICENSE}"
1257 else
1258 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1259 lic="${PORTDIR}/licenses/${lic}"
1260 elif [ -e "${PWD}/${lic}" ] ; then
1261 lic="${PWD}/${lic}"
1262 elif [ -e "${lic}" ] ; then
1263 lic="${lic}"
1264 fi
1265 fi
1266 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1267 local l="`basename ${lic}`"
1268
1269 # here is where we check for the licenses the user already
1270 # accepted ... if we don't find a match, we make the user accept
1271 local shopts=$-
1272 local alic
1273 set -o noglob #so that bash doesn't expand "*"
1274 for alic in ${ACCEPT_LICENSE} ; do
1275 if [[ ${alic} == ${l} ]]; then
1276 set +o noglob; set -${shopts} #reset old shell opts
1277 return 0
1278 fi
1279 done
1280 set +o noglob; set -$shopts #reset old shell opts
1281
1282 local licmsg=$(emktemp)
1283 cat <<-EOF > ${licmsg}
1284 **********************************************************
1285 The following license outlines the terms of use of this
1286 package. You MUST accept this license for installation to
1287 continue. When you are done viewing, hit 'q'. If you
1288 CTRL+C out of this, the install will not run!
1289 **********************************************************
1290
1291 EOF
1292 cat ${lic} >> ${licmsg}
1293 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1294 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1295 read alic
1296 case ${alic} in
1297 yes|Yes|y|Y)
1298 return 0
1299 ;;
1300 *)
1301 echo;echo;echo
1302 eerror "You MUST accept the license to continue! Exiting!"
1303 die "Failed to accept license"
1304 ;;
1305 esac
1306}
1307
1308# @FUNCTION: cdrom_get_cds
1309# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1310# @DESCRIPTION:
1311# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1312# the whole 'non-interactive' policy, but damnit I want CD support !
1313#
1314# With these cdrom functions we handle all the user interaction and
1315# standardize everything. All you have to do is call cdrom_get_cds()
1316# and when the function returns, you can assume that the cd has been
1317# found at CDROM_ROOT.
1318#
1319# The function will attempt to locate a cd based upon a file that is on
1320# the cd. The more files you give this function, the more cds
1321# the cdrom functions will handle.
1322#
1323# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1324# etc... If you want to give the cds better names, then just export
1325# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1326# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1327# also use the CDROM_NAME_SET bash array.
1328#
1329# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1330cdrom_get_cds() {
1331 # first we figure out how many cds we're dealing with by
1332 # the # of files they gave us
1333 local cdcnt=0
1334 local f=
1335 for f in "$@" ; do
1336 ((++cdcnt))
1337 export CDROM_CHECK_${cdcnt}="$f"
1338 done
1339 export CDROM_TOTAL_CDS=${cdcnt}
1340 export CDROM_CURRENT_CD=1
1341
1342 # now we see if the user gave use CD_ROOT ...
1343 # if they did, let's just believe them that it's correct
1344 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1345 local var=
1346 cdcnt=0
1347 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1348 ((++cdcnt))
1349 var="CD_ROOT_${cdcnt}"
1350 [[ -z ${!var} ]] && var="CD_ROOT"
1351 if [[ -z ${!var} ]] ; then 983 if [[ -z ${size} ]] ; then
1352 eerror "You must either use just the CD_ROOT" 984 insinto /usr/share/pixmaps
1353 eerror "or specify ALL the CD_ROOT_X variables." 985 else
1354 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 986 insinto /usr/share/icons/${theme}/${size}/${context}
1355 die "could not locate CD_ROOT_${cdcnt}"
1356 fi 987 fi
1357 done
1358 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1360 export CDROM_SET=-1
1361 for f in ${CDROM_CHECK_1//:/ } ; do
1362 ((++CDROM_SET))
1363 [[ -e ${CD_ROOT}/${f} ]] && break
1364 done
1365 export CDROM_MATCH=${f}
1366 return
1367 fi
1368 988
1369 # User didn't help us out so lets make sure they know they can 989 if [[ ${funcname} == doicon ]] ; then
1370 # simplify the whole process ...
1371 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1372 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1373 echo
1374 einfo "If you do not have the CD, but have the data files"
1375 einfo "mounted somewhere on your filesystem, just export"
1376 einfo "the variable CD_ROOT so that it points to the"
1377 einfo "directory containing the files."
1378 echo
1379 einfo "For example:"
1380 einfo "export CD_ROOT=/mnt/cdrom"
1381 echo
1382 else
1383 if [[ -n ${CDROM_NAME_SET} ]] ; then
1384 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1385 cdcnt=0
1386 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1387 ((++cdcnt))
1388 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1389 done
1390 fi
1391
1392 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1393 cdcnt=0
1394 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1395 ((++cdcnt))
1396 var="CDROM_NAME_${cdcnt}"
1397 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1398 done
1399 echo
1400 einfo "If you do not have the CDs, but have the data files"
1401 einfo "mounted somewhere on your filesystem, just export"
1402 einfo "the following variables so they point to the right place:"
1403 einfon ""
1404 cdcnt=0
1405 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1406 ((++cdcnt))
1407 echo -n " CD_ROOT_${cdcnt}"
1408 done
1409 echo
1410 einfo "Or, if you have all the files in the same place, or"
1411 einfo "you only have one cdrom, you can export CD_ROOT"
1412 einfo "and that place will be used as the same data source"
1413 einfo "for all the CDs."
1414 echo
1415 einfo "For example:"
1416 einfo "export CD_ROOT_1=/mnt/cdrom"
1417 echo
1418 fi
1419
1420 export CDROM_SET=""
1421 export CDROM_CURRENT_CD=0
1422 cdrom_load_next_cd
1423}
1424
1425# @FUNCTION: cdrom_load_next_cd
1426# @DESCRIPTION:
1427# Some packages are so big they come on multiple CDs. When you're done reading
1428# files off a CD and want access to the next one, just call this function.
1429# Again, all the messy details of user interaction are taken care of for you.
1430# Once this returns, just read the variable CDROM_ROOT for the location of the
1431# mounted CD. Note that you can only go forward in the CD list, so make sure
1432# you only call this function when you're done using the current CD.
1433cdrom_load_next_cd() {
1434 local var
1435 ((++CDROM_CURRENT_CD))
1436
1437 unset CDROM_ROOT
1438 var=CD_ROOT_${CDROM_CURRENT_CD}
1439 [[ -z ${!var} ]] && var="CD_ROOT"
1440 if [[ -z ${!var} ]] ; then 990 if [[ -f $1 ]] ; then
1441 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 991 doins "${1}"
1442 _cdrom_locate_file_on_cd ${!var} 992 elif [[ -d $1 ]] ; then
1443 else 993 shopt -s nullglob
1444 export CDROM_ROOT=${!var} 994 doins "${1}"/*.{png,svg}
1445 fi 995 shopt -u nullglob
1446
1447 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1448}
1449
1450# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1451# functions. this should *never* be called from an ebuild.
1452# all it does is try to locate a give file on a cd ... if the cd isn't
1453# found, then a message asking for the user to insert the cdrom will be
1454# displayed and we'll hang out here until:
1455# (1) the file is found on a mounted cdrom
1456# (2) the user hits CTRL+C
1457_cdrom_locate_file_on_cd() {
1458 local mline=""
1459 local showedmsg=0 showjolietmsg=0
1460
1461 while [[ -z ${CDROM_ROOT} ]] ; do
1462 local i=0
1463 local -a cdset=(${*//:/ })
1464 if [[ -n ${CDROM_SET} ]] ; then
1465 cdset=(${cdset[${CDROM_SET}]})
1466 fi
1467
1468 while [[ -n ${cdset[${i}]} ]] ; do
1469 local dir=$(dirname ${cdset[${i}]})
1470 local file=$(basename ${cdset[${i}]})
1471
1472 local point= node= fs= foo=
1473 while read point node fs foo ; do
1474 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1475 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1476 && continue
1477 point=${point//\040/ }
1478 [[ ! -d ${point}/${dir} ]] && continue
1479 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1480 export CDROM_ROOT=${point}
1481 export CDROM_SET=${i}
1482 export CDROM_MATCH=${cdset[${i}]}
1483 return
1484 done <<< "$(get_mounts)"
1485
1486 ((++i))
1487 done
1488
1489 echo
1490 if [[ ${showedmsg} -eq 0 ]] ; then
1491 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1492 if [[ -z ${CDROM_NAME} ]] ; then
1493 einfo "Please insert+mount the cdrom for ${PN} now !"
1494 else 996 else
1495 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 997 eerror "${1} is not a valid file/directory!"
998 exit 1
1496 fi 999 fi
1497 else 1000 else
1498 if [[ -z ${CDROM_NAME_1} ]] ; then 1001 break
1499 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1500 else
1501 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1502 einfo "Please insert+mount the ${!var} cdrom now !"
1503 fi
1504 fi 1002 fi
1505 showedmsg=1 1003 shift 1;;
1506 fi 1004 esac
1507 einfo "Press return to scan for the cd again"
1508 einfo "or hit CTRL+C to abort the emerge."
1509 echo
1510 if [[ ${showjolietmsg} -eq 0 ]] ; then
1511 showjolietmsg=1
1512 else
1513 ewarn "If you are having trouble with the detection"
1514 ewarn "of your CD, it is possible that you do not have"
1515 ewarn "Joliet support enabled in your kernel. Please"
1516 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1517 ebeep 5
1518 fi
1519 read || die "something is screwed with your system"
1520 done 1005 done
1006 if [[ ${funcname} == newicon ]] ; then
1007 newins "$@"
1008 fi
1009 ) || die
1010}
1011
1012# @FUNCTION: doicon
1013# @USAGE: [options] <icons>
1014# @DESCRIPTION:
1015# Install icon into the icon directory /usr/share/icons or into
1016# /usr/share/pixmaps if "--size" is not set.
1017# This is useful in conjunction with creating desktop/menu files.
1018#
1019# @CODE
1020# options:
1021# -s, --size
1022# !!! must specify to install into /usr/share/icons/... !!!
1023# size of the icon, like 48 or 48x48
1024# supported icon sizes are:
1025# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1026# -c, --context
1027# defaults to "apps"
1028# -t, --theme
1029# defaults to "hicolor"
1030#
1031# icons: list of icons
1032#
1033# example 1: doicon foobar.png fuqbar.svg suckbar.png
1034# results in: insinto /usr/share/pixmaps
1035# doins foobar.png fuqbar.svg suckbar.png
1036#
1037# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1038# results in: insinto /usr/share/icons/hicolor/48x48/apps
1039# doins foobar.png fuqbar.png blobbar.png
1040# @CODE
1041doicon() {
1042 _iconins ${FUNCNAME} "$@"
1043}
1044
1045# @FUNCTION: newicon
1046# @USAGE: [options] <icon> <newname>
1047# @DESCRIPTION:
1048# Like doicon, install the specified icon as newname.
1049#
1050# @CODE
1051# example 1: newicon foobar.png NEWNAME.png
1052# results in: insinto /usr/share/pixmaps
1053# newins foobar.png NEWNAME.png
1054#
1055# example 2: newicon -s 48 foobar.png NEWNAME.png
1056# results in: insinto /usr/share/icons/hicolor/48x48/apps
1057# newins foobar.png NEWNAME.png
1058# @CODE
1059newicon() {
1060 _iconins ${FUNCNAME} "$@"
1521} 1061}
1522 1062
1523# @FUNCTION: strip-linguas 1063# @FUNCTION: strip-linguas
1524# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>] 1064# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1525# @DESCRIPTION: 1065# @DESCRIPTION:
1532# of the lists. 1072# of the lists.
1533strip-linguas() { 1073strip-linguas() {
1534 local ls newls nols 1074 local ls newls nols
1535 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1075 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1536 local op=$1; shift 1076 local op=$1; shift
1537 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1077 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1538 local d f 1078 local d f
1539 for d in "$@" ; do 1079 for d in "$@" ; do
1540 if [[ ${op} == "-u" ]] ; then 1080 if [[ ${op} == "-u" ]] ; then
1541 newls=${ls} 1081 newls=${ls}
1542 else 1082 else
1543 newls="" 1083 newls=""
1544 fi 1084 fi
1545 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1085 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1546 if [[ ${op} == "-i" ]] ; then 1086 if [[ ${op} == "-i" ]] ; then
1547 hasq ${f} ${ls} && newls="${newls} ${f}" 1087 has ${f} ${ls} && newls="${newls} ${f}"
1548 else 1088 else
1549 hasq ${f} ${ls} || newls="${newls} ${f}" 1089 has ${f} ${ls} || newls="${newls} ${f}"
1550 fi 1090 fi
1551 done 1091 done
1552 ls=${newls} 1092 ls=${newls}
1553 done 1093 done
1554 else 1094 else
1556 fi 1096 fi
1557 1097
1558 nols="" 1098 nols=""
1559 newls="" 1099 newls=""
1560 for f in ${LINGUAS} ; do 1100 for f in ${LINGUAS} ; do
1561 if hasq ${f} ${ls} ; then 1101 if has ${f} ${ls} ; then
1562 newls="${newls} ${f}" 1102 newls="${newls} ${f}"
1563 else 1103 else
1564 nols="${nols} ${f}" 1104 nols="${nols} ${f}"
1565 fi 1105 fi
1566 done 1106 done
1567 [[ -n ${nols} ]] \ 1107 [[ -n ${nols} ]] \
1568 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1108 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1569 export LINGUAS=${newls:1} 1109 export LINGUAS=${newls:1}
1570} 1110}
1571 1111
1572# @FUNCTION: preserve_old_lib 1112# @FUNCTION: preserve_old_lib
1573# @USAGE: <libs to preserve> [more libs] 1113# @USAGE: <libs to preserve> [more libs]
1583 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1123 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1584 die "Invalid preserve_old_lib() usage" 1124 die "Invalid preserve_old_lib() usage"
1585 fi 1125 fi
1586 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1126 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1587 1127
1128 # let portage worry about it
1129 has preserve-libs ${FEATURES} && return 0
1130
1588 local lib dir 1131 local lib dir
1589 for lib in "$@" ; do 1132 for lib in "$@" ; do
1590 [[ -e ${ROOT}/${lib} ]] || continue 1133 [[ -e ${ROOT}/${lib} ]] || continue
1591 dir=${lib%/*} 1134 dir=${lib%/*}
1592 dodir ${dir} || die "dodir ${dir} failed" 1135 dodir ${dir} || die "dodir ${dir} failed"
1602preserve_old_lib_notify() { 1145preserve_old_lib_notify() {
1603 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1146 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1604 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1147 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1605 die "Invalid preserve_old_lib_notify() usage" 1148 die "Invalid preserve_old_lib_notify() usage"
1606 fi 1149 fi
1150
1151 # let portage worry about it
1152 has preserve-libs ${FEATURES} && return 0
1607 1153
1608 local lib notice=0 1154 local lib notice=0
1609 for lib in "$@" ; do 1155 for lib in "$@" ; do
1610 [[ -e ${ROOT}/${lib} ]] || continue 1156 [[ -e ${ROOT}/${lib} ]] || continue
1611 if [[ ${notice} -eq 0 ]] ; then 1157 if [[ ${notice} -eq 0 ]] ; then
1615 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1161 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1616 ewarn "in order to remove these old dependencies. If you do not have this" 1162 ewarn "in order to remove these old dependencies. If you do not have this"
1617 ewarn "helper program, simply emerge the 'gentoolkit' package." 1163 ewarn "helper program, simply emerge the 'gentoolkit' package."
1618 ewarn 1164 ewarn
1619 fi 1165 fi
1620 ewarn " # revdep-rebuild --library ${lib##*/}" 1166 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1621 done 1167 done
1622 if [[ ${notice} -eq 1 ]] ; then
1623 ewarn
1624 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1625 ewarn "delete the old libraries."
1626 fi
1627} 1168}
1628 1169
1629# @FUNCTION: built_with_use 1170# @FUNCTION: built_with_use
1630# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1171# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1631# @DESCRIPTION: 1172# @DESCRIPTION:
1173#
1174# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1175#
1632# A temporary hack until portage properly supports DEPENDing on USE 1176# A temporary hack until portage properly supports DEPENDing on USE
1633# flags being enabled in packages. This will check to see if the specified 1177# flags being enabled in packages. This will check to see if the specified
1634# DEPEND atom was built with the specified list of USE flags. The 1178# DEPEND atom was built with the specified list of USE flags. The
1635# --missing option controls the behavior if called on a package that does 1179# --missing option controls the behavior if called on a package that does
1636# not actually support the defined USE flags (aka listed in IUSE). 1180# not actually support the defined USE flags (aka listed in IUSE).
1637# The default is to abort (call die). The -a and -o flags control 1181# The default is to abort (call die). The -a and -o flags control
1638# the requirements of the USE flags. They correspond to "and" and "or" 1182# the requirements of the USE flags. They correspond to "and" and "or"
1639# logic. So the -a flag means all listed USE flags must be enabled 1183# logic. So the -a flag means all listed USE flags must be enabled
1640# while the -o flag means at least one of the listed fIUSE flags must be 1184# while the -o flag means at least one of the listed IUSE flags must be
1641# enabled. The --hidden option is really for internal use only as it 1185# enabled. The --hidden option is really for internal use only as it
1642# means the USE flag we're checking is hidden expanded, so it won't be found 1186# means the USE flag we're checking is hidden expanded, so it won't be found
1643# in IUSE like normal USE flags. 1187# in IUSE like normal USE flags.
1644# 1188#
1645# Remember that this function isn't terribly intelligent so order of optional 1189# Remember that this function isn't terribly intelligent so order of optional
1680 die) die "Unable to determine what USE flags $PKG was built with";; 1224 die) die "Unable to determine what USE flags $PKG was built with";;
1681 esac 1225 esac
1682 fi 1226 fi
1683 1227
1684 if [[ ${hidden} == "no" ]] ; then 1228 if [[ ${hidden} == "no" ]] ; then
1685 local IUSE_BUILT=$(<${IUSEFILE}) 1229 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1686 # Don't check USE_EXPAND #147237 1230 # Don't check USE_EXPAND #147237
1687 local expand 1231 local expand
1688 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1232 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1689 if [[ $1 == ${expand}_* ]] ; then 1233 if [[ $1 == ${expand}_* ]] ; then
1690 expand="" 1234 expand=""
1691 break 1235 break
1692 fi 1236 fi
1693 done 1237 done
1694 if [[ -n ${expand} ]] ; then 1238 if [[ -n ${expand} ]] ; then
1695 if ! has $1 ${IUSE_BUILT} ; then 1239 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1696 case ${missing_action} in 1240 case ${missing_action} in
1697 true) return 0;; 1241 true) return 0;;
1698 false) return 1;; 1242 false) return 1;;
1699 die) die "$PKG does not actually support the $1 USE flag!";; 1243 die) die "$PKG does not actually support the $1 USE flag!";;
1700 esac 1244 esac
1764 ) || die 1308 ) || die
1765 else 1309 else
1766 newbin "${tmpwrapper}" "${wrapper}" || die 1310 newbin "${tmpwrapper}" "${wrapper}" || die
1767 fi 1311 fi
1768} 1312}
1313
1314# @FUNCTION: path_exists
1315# @USAGE: [-a|-o] <paths>
1316# @DESCRIPTION:
1317# Check if the specified paths exist. Works for all types of paths
1318# (files/dirs/etc...). The -a and -o flags control the requirements
1319# of the paths. They correspond to "and" and "or" logic. So the -a
1320# flag means all the paths must exist while the -o flag means at least
1321# one of the paths must exist. The default behavior is "and". If no
1322# paths are specified, then the return value is "false".
1323path_exists() {
1324 local opt=$1
1325 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1326
1327 # no paths -> return false
1328 # same behavior as: [[ -e "" ]]
1329 [[ $# -eq 0 ]] && return 1
1330
1331 local p r=0
1332 for p in "$@" ; do
1333 [[ -e ${p} ]]
1334 : $(( r += $? ))
1335 done
1336
1337 case ${opt} in
1338 -a) return $(( r != 0 )) ;;
1339 -o) return $(( r == $# )) ;;
1340 esac
1341}
1342
1343# @FUNCTION: in_iuse
1344# @USAGE: <flag>
1345# @DESCRIPTION:
1346# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1347# as necessary.
1348#
1349# Note that this function should not be used in the global scope.
1350in_iuse() {
1351 debug-print-function ${FUNCNAME} "${@}"
1352 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1353
1354 local flag=${1}
1355 local liuse=( ${IUSE} )
1356
1357 has "${flag}" "${liuse[@]#[+-]}"
1358}
1359
1360# @FUNCTION: use_if_iuse
1361# @USAGE: <flag>
1362# @DESCRIPTION:
1363# Return true if the given flag is in USE and IUSE.
1364#
1365# Note that this function should not be used in the global scope.
1366use_if_iuse() {
1367 in_iuse $1 || return 1
1368 use $1
1369}
1370
1371# @FUNCTION: usex
1372# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1373# @DESCRIPTION:
1374# Proxy to declare usex for package managers or EAPIs that do not provide it
1375# and use the package manager implementation when available (i.e. EAPI >= 5).
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378if has "${EAPI:-0}" 0 1 2 3 4; then
1379 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1380fi
1381
1382# @FUNCTION: prune_libtool_files
1383# @USAGE: [--all|--modules]
1384# @DESCRIPTION:
1385# Locate unnecessary libtool files (.la) and libtool static archives
1386# (.a) and remove them from installation image.
1387#
1388# By default, .la files are removed whenever the static linkage can
1389# either be performed using pkg-config or doesn't introduce additional
1390# flags.
1391#
1392# If '--modules' argument is passed, .la files for modules (plugins) are
1393# removed as well. This is usually useful when the package installs
1394# plugins and the plugin loader does not use .la files.
1395#
1396# If '--all' argument is passed, all .la files are removed without
1397# performing any heuristic on them. You shouldn't ever use that,
1398# and instead report a bug in the algorithm instead.
1399#
1400# The .a files are only removed whenever corresponding .la files state
1401# that they should not be linked to, i.e. whenever these files
1402# correspond to plugins.
1403#
1404# Note: if your package installs both static libraries and .pc files,
1405# you need to add pkg-config to your DEPEND.
1406prune_libtool_files() {
1407 debug-print-function ${FUNCNAME} "$@"
1408
1409 local removing_all removing_modules opt
1410 for opt; do
1411 case "${opt}" in
1412 --all)
1413 removing_all=1
1414 removing_modules=1
1415 ;;
1416 --modules)
1417 removing_modules=1
1418 ;;
1419 *)
1420 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1421 esac
1422 done
1423
1424 local f
1425 local queue=()
1426 while IFS= read -r -d '' f; do # for all .la files
1427 local archivefile=${f/%.la/.a}
1428
1429 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1430
1431 local reason pkgconfig_scanned
1432
1433 # Remove static libs we're not supposed to link against.
1434 if grep -q '^shouldnotlink=yes$' "${f}"; then
1435 if [[ -f ${archivefile} ]]; then
1436 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1437 queue+=( "${archivefile}" )
1438 fi
1439
1440 # The .la file may be used by a module loader, so avoid removing it
1441 # unless explicitly requested.
1442 if [[ ${removing_modules} ]]; then
1443 reason='module'
1444 fi
1445
1446 # Remove .la files when:
1447 # - user explicitly wants us to remove all .la files,
1448 # - respective static archive doesn't exist,
1449 # - they are covered by a .pc file already,
1450 # - they don't provide any new information (no libs & no flags).
1451
1452 elif [[ ${removing_all} ]]; then
1453 reason='requested'
1454 elif [[ ! -f ${archivefile} ]]; then
1455 reason='no static archive'
1456 elif [[ ! $(sed -nre \
1457 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1458 "${f}") ]]; then
1459 reason='no libs & flags'
1460 else
1461 if [[ ! ${pkgconfig_scanned} ]]; then
1462 # Create a list of all .pc-covered libs.
1463 local pc_libs=()
1464 if [[ ! ${removing_all} ]]; then
1465 local pc
1466 local tf=${T}/prune-lt-files.pc
1467 local pkgconf=$(tc-getPKG_CONFIG)
1468
1469 while IFS= read -r -d '' pc; do # for all .pc files
1470 local arg
1471
1472 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1473 for arg in $("${pkgconf}" --libs "${tf}"); do
1474 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1475 done
1476 done < <(find "${D}" -type f -name '*.pc' -print0)
1477
1478 rm -f "${tf}"
1479 fi
1480
1481 pkgconfig_scanned=1
1482 fi
1483
1484 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1485 fi
1486
1487 if [[ ${reason} ]]; then
1488 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1489 queue+=( "${f}" )
1490 fi
1491 done < <(find "${D}" -xtype f -name '*.la' -print0)
1492
1493 if [[ ${queue[@]} ]]; then
1494 rm -f "${queue[@]}"
1495 fi
1496}
1497
1498check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1499
1500fi

Legend:
Removed from v.1.296  
changed lines
  Added in v.1.409

  ViewVC Help
Powered by ViewVC 1.1.20